package cn.iocoder.yudao.module.iot.dal.mysql.formula;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.module.iot.controller.admin.formula.vo.FormulaPageReqVO;
import cn.iocoder.yudao.module.iot.dal.dataobject.formula.FormulaDO;
import org.apache.ibatis.annotations.Mapper;

/**
 * 计算公式 Mapper
 *
 * @author 内蒙必硕
 */
@Mapper
public interface FormulaMapper extends BaseMapperX<FormulaDO> {

    default PageResult<FormulaDO> selectPage(FormulaPageReqVO reqVO) {
        return selectPage(reqVO, new LambdaQueryWrapperX<FormulaDO>()
                .likeIfPresent(FormulaDO::getName, reqVO.getName())
                .eqIfPresent(FormulaDO::getFormulaCode, reqVO.getFormulaCode())
                .eqIfPresent(FormulaDO::getFormula, reqVO.getFormula())
                .eqIfPresent(FormulaDO::getResultType, reqVO.getResultType())
                .eqIfPresent(FormulaDO::getMachineId, reqVO.getMachineId())
                .eqIfPresent(FormulaDO::getRemark, reqVO.getRemark())
                .eqIfPresent(FormulaDO::getIsEnable, reqVO.getIsEnable())
                .betweenIfPresent(FormulaDO::getCreateTime, reqVO.getCreateTime())
                .orderByDesc(FormulaDO::getId));
    }

}